//+------------------------------------------------------------------+
//|                                Profit Generator - Daily Bars.mq4 |
//|                       No Copyright, created in 2006, Open Source |
//|                                         http://www.forex-tsd.com |
//|        Daily Bar Values are hard coded. Use on lower timeframes. | 
//|        Freely receive, Freely give. Please post updated version. |
//+------------------------------------------------------------------+
#property copyright "Created in 2006, Open Source Project"
#property link      "http://www.forex-tsd.com"

extern int ID;
extern double lots=1.0;
extern bool MM = false; //Use Money Management or not
extern int Risk = 10; //10%


extern int stoploss=30,takeprofit=40;
extern int MaxTrades=1;
extern bool UseHourTrade = False;
extern int  FromHourTrade = 8;
extern int  ToHourTrade = 18;
extern bool UseTrail=false;
extern int TrailingStop=0;
extern int LongBar=10;

void deinit() 
{
   Comment("");
}

/*
int gb(){
   int in;
   if(!GlobalVariableCheck("PG2_id_storage")){
      GlobalVariableSet("PG2_id_storage",111112);
      in=111112;
   }else{
      in=NormalizeDouble(GlobalVariableGet("PG2_id_storage"),0);
   }
   return(in);
}
      
*/  

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

int start(){
   if(UseTrail)Trailing();
   if(orderscnt()==0){
      if (UseHourTrade){
         if(!(Hour()>=FromHourTrade&&Hour()<=ToHourTrade)){
            Comment("Non-Trading Hours!");
            return(0);
         }
      }
   }
//   if (Period() < 30) {Comment("change to M30 or higher pls"); return(0); }
   if(orderscnt()<MaxTrades){
      if(MM==true) lots = LotSize();
//      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
   }   
}

void CheckOpen()
{ 
  // ID=gb();  
   double tp,sl;
   double Hi, Lo, Op;
   
   Hi = iHigh(NULL, PERIOD_D1, 0); //Change the 0 to 1 if you want to play with yesterday's high
   Lo = iLow(NULL, PERIOD_D1, 0);  //Change the 0 to 1 if you want to play with yesterday's low
   Op = iOpen(NULL, PERIOD_D1, 0);
   
//   Print(Hi, ",", Lo); // This shows how the value of hi and lo changes during the day

//   if ((High[0]-Low[0])>LongBar*Point && Open[0]<(High[0]+Low[0])/2 && Ask < Open[0])
   if ((Hi-Lo)>LongBar*Point && Op<(Hi+Lo)/2 && Ask < Op)
   {
      if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;}
      if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,"Profit Generator",ID,0,Blue); 
   }
//   if ((High[0]-Low[0])>LongBar*Point && Open[0]>(High[0]+Low[0])/2 && Bid > Open[0])
   if ((Hi-Lo)>LongBar*Point && Op>(Hi+Lo)/2 && Bid > Op)
   {
      if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
      if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,"Profit Generator",ID,0,Red); 
   }
}
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 


void Trailing(){
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==ID && Symbol()==OrderSymbol() ){
         if(OrderType()==OP_BUY){
            if(TrailingStop>0){
               if(Bid-OrderOpenPrice()>Point*TrailingStop){
                  if(OrderStopLoss()<Bid-Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
               }
            }
         }else{
            if(TrailingStop>0){
               if(OrderOpenPrice()-Ask>Point*TrailingStop){
                  if(OrderStopLoss()>Ask+Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}